// Copyright(c) 1994-1996 Sun Microsystems Inc.
// Copyright(c) 1994-1996 Information-technology Promotion Agency, Japan
//
// Permissions to use, copy, modify and distribute this software are
// governed by the terms and conditions set forth in the file COPYRIGHT,
// located in the ADLT release package.
//
// ************************************************************************
//
// SCCS:        @(#)StockBroker.hh	1.1 11/19/96
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	Stockbroker example (C++)
// NAME:	StockBroker.hh
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
//      Cyrille Bareau, The Open Group- Jan 98 : updated for ADL2.0
// 		
// ************************************************************************

// #include <stdio.h>

class BadCall {
public:
  bool bad_account;
  bool bad_stock_symbol;
  bool insuf_stock ;
};


class StockBrokerAux {
public:
  static int getPriceSymbol(char *symbol);
  static bool bad_sym(char *symbol);
};


class StockBroker {
public:
  long Cash_Balance() throw (BadCall);
  
  long Stock_Balance(char* symbol) throw (BadCall);

  void Buy(char* symbol, long no_of_shares) throw (BadCall);
  
  void Sell(char *symbol, int no_of_shares) throw (BadCall);

  bool bad_sym(char *s);
};
