//*****************************************************************************
// File Generated by ADLT Version 2.0
//
//        Name: bankAccountACO.cpp
//       ident: $Id: myBankAccountACO.cpp,v 1.2 1998/05/28 15:41:16 mallet Exp $
//     $Source: /vobstore/cvsstore/adl/adl2/src/examples/cpp/bank_example/adl_test/myBankAccountACO.cpp,v $
//   $Revision: 1.2 $
//       $Date: 1998/05/28 15:41:16 $
//    ADL file: bank.adl
//
//
//*****************************************************************************

#include "myBankAccountACO.hh"
#include "ADLResultCodes.h"
#include "ADLString.hh"


long myBankAccountACO::deposit(long amt) throw (negativeAmountExc) {

  long __ADL_returned = 0;

  // following cast is safe, we now that the realObject is an
  // instanceof myBankAccount.
  myBankAccount *myBankAccountObject = (myBankAccount *)realObject;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  // no call-state expression

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking myBankAccount::deposit ***");
    testContext->infoline(adlstr.reset() << "\tlong amt = " << amt);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_negativeAmountExc = false;
  negativeAmountExc *thrown_negativeAmountExc = NULL;
  if (!skipAssertions) {
    try {
      __ADL_returned = bankAccountACO::deposit(amt);
    }
    catch (negativeAmountExc& depositExc) {
      wasThrownException = true;
      thrownException = &depositExc;
      wasThrown_negativeAmountExc = true;
      thrown_negativeAmountExc = &depositExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling myBankAccount::deposit");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
    
    // evaluation of the abnormal clause
    abnormal = (wasThrown_negativeAmountExc);
    
    // evaluation of the normal clause
    normal = !abnormal;
    
  }

  testContext->assertionStart("get_balance()>=authorizedOverdraft()");
  if (!skipAssertions) {
    long __ADL_tmp_0 = myBankAccountObject->get_balance();
    long __ADL_tmp_1 = myBankAccountObject->authorizedOverdraft();
    bool __ADL_tmp_2 = (__ADL_tmp_0 >= __ADL_tmp_1);
    tddRes = __ADL_tmp_2;

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_balance()\t-> " << __ADL_tmp_0);
      testContext->infoline(adlstr.reset() << "authorizedOverdraft()\t-> " << __ADL_tmp_1);
      testContext->infoline(adlstr.reset() << "get_balance()>=authorizedOverdraft()\t-> " << __ADL_tmp_2);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return __ADL_returned;
}


long myBankAccountACO::withdraw(long amt)
  throw (negativeAmountExc, insufficientFundsExc) {
  long __ADL_returned = 0;

  // following cast is safe, we now that the realObject is an
  // instanceof bank.
  myBankAccount *myBankAccountObject = (myBankAccount *)realObject;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  // Saved state checked in assertions
  long __ADL_savTmp_0 = 0;
  long __ADL_savTmp_1 = 0;
  long __ADL_savTmp_2 = 0;
  if (!skipAssertions) {
    __ADL_savTmp_0 = myBankAccountObject->get_balance();
    __ADL_savTmp_1 = myBankAccountObject->get_balance();
    __ADL_savTmp_2 = myBankAccountObject->get_balance();
  }

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking myBankAccount::withdraw ***");
    testContext->infoline(adlstr.reset() << "\tlong amt = " << amt);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_negativeAmountExc = false;
  negativeAmountExc *thrown_negativeAmountExc = NULL;
  bool wasThrown_insufficientFundsExc = false;
  insufficientFundsExc *thrown_insufficientFundsExc = NULL;
  if (!skipAssertions) {
    try {
      __ADL_returned = myBankAccountObject->withdraw(amt);
    }
    catch (negativeAmountExc& withdrawExc) {
      wasThrownException = true;
      thrownException = &withdrawExc;
      wasThrown_negativeAmountExc = true;
      thrown_negativeAmountExc = &withdrawExc;
    }
    catch (insufficientFundsExc& withdrawExc) {
      wasThrownException = true;
      thrownException = &withdrawExc;
      wasThrown_insufficientFundsExc = true;
      thrown_insufficientFundsExc = &withdrawExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling myBankAccount::withdraw");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
    
    // evaluation of the abnormal clause
    abnormal = (wasThrown_negativeAmountExc || wasThrown_insufficientFundsExc);
    
    // evaluation of the normal clause
    normal = !abnormal;
    
  }

  testContext->assertionStart("(amt < 0) <:> thrown (negativeAmountExc)");
  if (!skipAssertions) {
    long __ADL_tmp_0 = amt;
    bool __ADL_tmp_1 = (__ADL_tmp_0 < 0);
    bool __ADL_tmp_2 = wasThrown_negativeAmountExc;
    bool __ADL_tmp_3 = ((!__ADL_tmp_1 || abnormal) && 
	      (!(abnormal && __ADL_tmp_2) || __ADL_tmp_1));
    tddRes = __ADL_tmp_3;

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "amt\t-> " << __ADL_tmp_0);
      testContext->infoline(adlstr.reset() << "(amt < 0)\t-> " << __ADL_tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(negativeAmountExc)\t-> " << __ADL_tmp_2);
      testContext->infoline(adlstr.reset() << "(amt < 0) <:> thrown (negativeAmountExc)\t-> " << __ADL_tmp_3);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  testContext->assertionStart("@get_balance() - amt < authorizedOverdraft() <:> thrown (insufficientFundsExc)");
  if (!skipAssertions) {
    long __ADL_tmp_0 = __ADL_savTmp_0;
    long __ADL_tmp_1 = amt;
    long __ADL_tmp_2 = __ADL_tmp_0 - __ADL_tmp_1;
    long __ADL_tmp_3 = myBankAccountObject->authorizedOverdraft();
    bool __ADL_tmp_4 = __ADL_tmp_2 < __ADL_tmp_3;
    bool __ADL_tmp_5 = wasThrown_insufficientFundsExc;
    bool __ADL_tmp_6 = ((!__ADL_tmp_4 || abnormal) && 
	      (!(abnormal && __ADL_tmp_5) || __ADL_tmp_4));
    tddRes = __ADL_tmp_6;

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << __ADL_tmp_0);
      testContext->infoline(adlstr.reset() << "amt\t-> " << __ADL_tmp_1);
      testContext->infoline(adlstr.reset() << "@get_balance()-amt\t-> " << __ADL_tmp_2);
      testContext->infoline(adlstr.reset() << "authorizedOverdraft()\t-> " << __ADL_tmp_3);
      testContext->infoline(adlstr.reset() << "@get_balance()-amt<authorizedOverdraft()\t-> " << __ADL_tmp_4);
      testContext->infoline(adlstr.reset() << "thrown(insufficientFundsExc)\t-> " << __ADL_tmp_5);
      testContext->infoline(adlstr.reset() << "@get_balance()-amt<authorizedOverdraft()) <:> thrown (insufficientFundsExc)\t-> " << __ADL_tmp_6);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (abnormal) {
    testContext->assertionStart("unchanged (get_balance())");
    if (!skipAssertions) {
      long __ADL_tmp_0 = myBankAccountObject->get_balance();
      long __ADL_tmp_1 = __ADL_savTmp_1;
      bool __ADL_tmp_2 = __ADL_tmp_0 == __ADL_tmp_1;
      tddRes = __ADL_tmp_2;
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << __ADL_tmp_0);
	testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << __ADL_tmp_1);
	testContext->infoline(adlstr.reset() << "unchanged (get_balance())\t-> " << __ADL_tmp_2);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
  }

  if (normal) {
    testContext->assertionStart("get_balance() == @get_balance() - amt");
    if (!skipAssertions) {
      long __ADL_tmp_0 = myBankAccountObject->get_balance();
      long __ADL_tmp_1 = __ADL_savTmp_2;
      long __ADL_tmp_2 = amt;
      long __ADL_tmp_3 = __ADL_tmp_1 - __ADL_tmp_2;
      bool __ADL_tmp_4 = __ADL_tmp_0 == __ADL_tmp_3;
      tddRes = __ADL_tmp_4;
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << __ADL_tmp_0);
	testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << __ADL_tmp_1);
	testContext->infoline(adlstr.reset() << "amt\t-> " << __ADL_tmp_2);
	testContext->infoline(adlstr.reset() << "@get_balance() - amt\t-> " << __ADL_tmp_3);
	testContext->infoline(adlstr.reset() << "get_balance() == @get_balance() - amt\t-> " << __ADL_tmp_4);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
    testContext->assertionStart("return == get_balance()");
    if (!skipAssertions) {
      long __ADL_tmp_0 = __ADL_returned;
      long __ADL_tmp_1 = myBankAccountObject->get_balance();
      bool __ADL_tmp_2 = (__ADL_tmp_0 == __ADL_tmp_1);
      tddRes = __ADL_tmp_2;
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "return\t-> " << __ADL_tmp_0);
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << __ADL_tmp_1);
	testContext->infoline(adlstr.reset() << "return == get_balance()\t-> " << __ADL_tmp_2);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
  }

  if (wasThrownException) throw;

  return __ADL_returned;
}
