// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// SCCS:        @(#)bank.hh	1.1 11/19/96
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bank.hh
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
#ifndef BANK_HH
#define BANK_HH


#include "bankAccount.hh"
#include "bankException.hh"


const int maxAccountsDefault = 16;


class bank {

private:

  int         maxAccounts;
  bankAccount **accountList;
  int         numAccts;
public:

  bank();
  bank(int bankSize);
  ~bank();

  int get_max_accounts();

  int get_active_accounts();

  bankAccount *find_account (long acctNumber) throw
  (accountNotFoundExc);

  bankAccount *
  open_account(long amount, long& acctNumber) throw
  (negativeAmountExc,
   bankFullExc);


  void
  close_account(long acctNumber) throw
  (accountNotFoundExc,
   accountNotZeroExc,
   invalidAccountExc);

  void
  close_account (bankAccount *ba) throw
  (accountNotZeroExc,
   invalidAccountExc);

  void
  close_all_accounts() throw
  (invalidAccountExc,
   accountNotFoundExc,
   accountNotZeroExc);

}; // end of class bank
#endif
