// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// SCCS:        @(#)bankAccount.hh	1.1 11/19/96
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bankAccount.hh
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
#ifndef BANKACCOUNT_HH
#define BANKACCOUNT_HH

#include "bankException.hh"

class bankAccount {

protected:

  long acct_number;
  long balance;

public:

  bankAccount();

  bankAccount (long acct, long bal = 0);

  long get_account_number();

  long get_balance();

  virtual long deposit (long amt) throw (negativeAmountExc);

  long withdraw (long amt) throw
    (negativeAmountExc,
    insufficientFundsExc);


}; /* end of class bankAccount */
#endif
