// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// SCCS:        @(#)bankException.hh	1.1 11/19/96
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bankException.hh
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Oct 23, 1996: Created
// 		
// ************************************************************************
#ifndef BANKEXCEPTION_HH
#define BANKEXCEPTION_HH

#ifndef __ADL__
#include <stdio.h>
#include <string.h>
#else
extern int sprintf ( char * , const char * , ... ) ;
extern char * strcpy ( char * , const char * ) ;
#endif

#ifndef NULL
#define NULL 0
#endif

class bankException
{

  protected:
  char *err_string;

  public:
  bankException();
  bankException(char *);

  virtual ~bankException();
  virtual char *get_string_value();
};

class accountNotFoundExc : public bankException
{

public:
  accountNotFoundExc();

};

class accountNotZeroExc : public bankException {

public:
  accountNotZeroExc();

};

class bankFullExc : public bankException {

public:
  bankFullExc();
  bankFullExc(long numAccts);

};

class insufficientFundsExc : public bankException {

public:
  insufficientFundsExc();
};

class invalidAccountExc : public bankException {

public:
  invalidAccountExc();
};

class invalidAccountNumberExc : public bankException {

public:
  invalidAccountNumberExc();
};


class negativeAmountExc : public bankException {

public:
  negativeAmountExc();
};

#endif
