//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//  
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//  
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/idl/stock_example/StockClient.java,v $
// $Revision: 1.4 $
// $Date: 1998/02/27 15:46:36 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	stock example
// NAME:	StockClient.java
// 	
// HISTORY:
// 	Cyril Inard d'Argence, The Open Group - Feb 5, 1998: Created
// 		
// ************************************************************************

package stock_example;
import stock_example.stock_app.*;

import java.io.*;
import ORG.opengroup.adl.runtime.ORBWrapper;
import org.omg.CORBA.IntHolder;


/**	
 * Stock broker client using the Adl ORBWrapper.
 */

public class StockClient {

  public static void main(String args[])
  {
     
     try{
        // create and initialize the ORB
        ORBWrapper orbWrapper = ORBWrapper.init(args, null);
        
        String fileName = System.getProperty
                          ("adl.initialreferencefile",
                           "StockIOR");
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String ior = br.readLine();
        br.close();

        Object obj = orbWrapper.string_to_object(ior);
        StockBrokerFactory stockBrokerFactory 
           = StockBrokerFactoryHelper.narrow((org.omg.CORBA.Object)obj);

        // create a stock broker
        StockBroker  stockBroker = stockBrokerFactory.makeStockBroker();

        System.out.println("Cash balance = " + stockBroker.Cash_Balance());
        System.out.println("Getting 5 shares of p1.");
        stockBroker.newProduct("p1",5);
        System.out.println("Cash balance = " + stockBroker.Cash_Balance());
        System.out.println("Buying 2 shares of p1.");
        stockBroker.Buy("p1",2);
        System.out.println("Cash balance = " + stockBroker.Cash_Balance());
     } catch (Exception e) {
        System.out.println("ERROR : " + e) ;
        e.printStackTrace(System.out);
     }
  }
}

// ***********************************************************************
// History Log:
// $Log: StockClient.java,v $
// Revision 1.4  1998/02/27 15:46:36  cinard
// Updated copyright notice.
//
// Revision 1.3  1998/02/17 10:57:29  mallet
// Merged v1.0 with development trunk
//
// Revision 1.2.2.1  1998/02/16 20:28:18  cinard
// New location of ORBWrapper taken into account.
//
// Revision 1.2  1998/02/12 16:04:23  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/02/10 17:36:09  cinard
// Implementations for IDL interfaces and other useful classes.
//
// ***********************************************************************

