// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/java/unit/weekUnit.java,v $
// $Revision: 1.5 $
// $Date: 1998/03/10 17:27:19 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	Unit example (JAVA)
// NAME:	weekUnit.java
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
/**	
 *  public class weekUnit
 *
 *  @version 	        @(#)weekUnit.java	1.1 11/19/96
 *  @date created       Nov 4, 1996
 *  @author	        Matt Evans
 *
 */


public class weekUnit extends timeUnit {

  public weekUnit (long weeks) {
    super ("weeks");

    dayUnit d  = new dayUnit(7);
    base_units = (long) (weeks * d.get_base_units());
    interval   = d.get_base_units();
  }

  public weekUnit (double weeks) {
    super ("weeks");

    dayUnit d  = new dayUnit(7);
    base_units = (long) (weeks * d.get_base_units());
    interval   = d.get_base_units();
  }

  public weekUnit (timeUnit t) {
    super ("weeks");

    dayUnit d  = new dayUnit(7);
    base_units = t.get_base_units();
    interval   = d.get_base_units();
  }

  public timeUnit convert_to (timeUnit u) {
    return new weekUnit (u.get_base_units() * interval);

  }
}
