//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/runtime/cpp/ADLDataSet.cpp,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 10:01:03 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C++ Runtime Environment - TDD datasets root class
// NAME:	ADLDataSet.cpp
// 	
// HISTORY:
//      Lionel Mallet, The Open Group RI  - Oct  26, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#include "ADLDataSet.hh"
#include "ADLString.hh"
#include <iostream.h>
#include <string.h>

void ADLDataSet::setLabel(char *text) {
  if (text != NULL) {
    if (this->label != NULL) delete this->label;
  
    this->label = new char[strlen(text) + 1];
    strcpy(this->label, text);
  }
}

void ADLDataSet::checkBounds(int index) throw (ADLRuntimeException) {
  if (index < 0 || index >= numValues) {
    throw ADLRuntimeException(ADLRuntime,
			      adlstr.reset()
			      << "ADLDataSet: index out of range ("
			      << index << "/" << numValues << ")");
  }
}

// ***********************************************************************
// History Log:
// $Log: ADLDataSet.cpp,v $
// Revision 1.5  1998/02/27 10:01:03  mallet
// Updated copyright notice.
//
// Revision 1.4  1998/02/19 09:45:47  mallet
// Changed signature and semantics of checkBounds to throw an
// ADLRuntimeException instead of returning a boolean.
// Changed signature of provide and relinquish to throw an
// ADLRuntimeException when checkBounds fails instead of returning NULL,
// which could be gently ignored.
//
// Revision 1.3  1998/02/12 16:04:26  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1997/11/21 16:44:01  mallet
// Replaced string by char* to become more portable: fixed setLabel method.
//
// Revision 1.1  1997/11/14 10:13:29  mallet
// Initial version of runtime classes for TDD datasets and ACOs.
//
//
// ***********************************************************************
